// msg_wm_converter.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <sstream>
#include <iostream>
#include <fstream>
#include <cassert>
#include <iterator>
#include <boost/spirit/fusion/iterator/detail/iterator_base.hpp>
#include <boost/xpressive/xpressive_static.hpp>
#include <boost/algorithm/string.hpp>

namespace {

using namespace std;
using namespace boost::xpressive;

template< class Out >
struct printer : action<printer>
{
  Out& out;
  printer(Out const& out_) : out(out_) { }

  template< class BidiIter >
  bool operator()(match_results<BidiIter> const& match, BidiIter cur)
  {
    out << match.str(1);
    return true;
  }
};

template< class Out >
printer<Out> make_printer(Out const& out_)
{
	return printer<Out>(out_);
}

// tag
mark_tag tag_MSG_XXX(1), tag_macro_body(2),
	tag_function_args(3), tag_arg_type(4),
	tag_if_directive(5), tag_directive(6);

// regex
/*
sregex re_directive =
	(as_xpr("#if")|as_xpr("#else")) >> -+_ >> _n;
*/

sregex re_MSG_XXX = "MSG_" >> +~as_xpr('(');

sregex re_define =
	as_xpr("#define ") >> (tag_MSG_XXX= re_MSG_XXX) >> -+_ >> _n >>
	(tag_macro_body= ( -+_ >> before( as_xpr('#')|as_xpr("//") ) ) ); //"+~(boost::xpressive::set='#','/')); 

sregex re_macro_body =
	-+_ >>
	as_xpr("func(") >> (tag_function_args= -*_) >> as_xpr(");") >>
	+_;

string gen_handler_type(string const& args, bool bLRESULT)
{
	sregex re_argument = epsilon >>
		(bos|as_xpr(',')) >> *_s >>
		(
			(s2= (as_xpr("CSize")|as_xpr("CPoint")))	|
			(s3= (as_xpr("wParam")|as_xpr("lParam")))	|
			(s4= (as_xpr("LOWORD")|as_xpr("HIWORD"))) |
			(as_xpr('(') >> (s1= -+_) >> as_xpr(')'))
		) >>
		*~as_xpr(',');

	stringstream out;

	if (bLRESULT)
		out << "LRESULT ";
	else
		out << "void ";

	out << "(Derived::*func)(";

	sregex_iterator cur(args.begin(), args.end(), re_argument);
	string::const_iterator first_pos = args.begin();
	sregex_iterator end;
	for( ; cur != end; ++cur) {
		smatch const& what = *cur;

		if (what[2])
			out << what[2].str() << " const&,";
		else if (what[3])
			out << boost::to_upper_copy(what[3].str()) << ",";
		else if (what[4])
			out << "WORD,";
		else if (what[1])
			out << what[1].str() << ",";
	}

	// remove trailing comma
	string out_ = out.str();
	out_ = regex_replace(out_, (s1= "," >> eos), string(""));

	return out_ + ")";
}

bool is_return_type_LRESULT(string const& macro_body)
{
	return regex_search(macro_body, "= (LRESULT)func" >> epsilon) ||
		regex_search(macro_body, "= func" >> epsilon);
}

string gen_msg_xxx(string const& str)
{
	return boost::to_lower_copy(str);
}

string gen_function_body(string const& macro_body)
{
	string body = macro_body;
	body = regex_replace(body, (s1= bol), string("\t"));
	body = regex_replace(body, (s1= " \\\n"), string("\n"));

	string fmt = "get_$1(xs)";
	body = regex_replace(body, (s1= "hWnd"), fmt);
	body = regex_replace(body, (s1= "uMsg"), fmt);
	body = regex_replace(body, (s1= "wParam"), fmt);
	body = regex_replace(body, (s1= "lParam"), fmt);
	body = regex_replace(body, (s1= "lResult"), fmt);
	body = regex_replace(body, (s1= "dwMsgMapID"), fmt);
	body = regex_replace(body, (s1= "bHandled"), fmt);
	body = regex_replace(body, (s1= "func"), string("(get_derived(xs).*func)"));

	body = regex_replace(body, (s1= "return TRUE"), string("return true"));
	body = regex_replace(body, (s1= "SetMsgHandled(TRUE)"), string("get_derived(xs).set_msg_handled(true)"));
	body = regex_replace(body, (s1= "IsMsgHandled()"), string("get_derived(xs).is_msg_handled()"));
	return body;
}

string parse(string const& in)
{
	stringstream out;
	out << "///////////////////////////////////////////////////////////////////////////////" << endl;
	out << "// GENERATED FROM atlcrack_h BY msg_wm_converter" << endl;
	out << "//" << endl << endl;

	sregex_iterator cur(in.begin(), in.end(), re_define);
	string::const_iterator first_pos = in.begin();
	sregex_iterator end;
	for( ; cur != end; ++cur) {
		smatch const& what = *cur;

		// pass unmatched string to output
		string::const_iterator last_pos = in.begin();
		advance(last_pos, what.position(0));
		out << string(first_pos, last_pos);
		// update first_pos
		first_pos = last_pos;
		advance(first_pos, what.length(0));


		string msg_xxx = gen_msg_xxx(what[tag_MSG_XXX]);
		out << endl << "// " << msg_xxx << endl << endl;

		string macro_body = what[tag_macro_body];
		smatch what_body;
		if (!regex_match(macro_body, what_body, re_macro_body)) {
			assert(false);
			continue;
		}

		string function_args = what_body[tag_function_args];
		bool bLRESULT = is_return_type_LRESULT(macro_body);
		out <<
			"template<"																				<< endl <<
			"\t" << gen_handler_type(function_args, bLRESULT)	<< endl <<
			">"																								<< endl <<
			"struct " << msg_xxx															<< endl <<
			"{"																								<< endl <<
			"\tstatic bool evaluate(arguments_reference xs)"	<< endl <<
			"\t{"																							<< endl <<
			"\t\tBOOST_STATIC_ASSERT(has_cracked_handlers);"	<< endl <<
			""																								<< endl <<
			gen_function_body(macro_body)											<<
			"\treturn false;"																	<< endl <<
			"\t}"																							<< endl <<
			"};"																							<< endl;
	}

	return out.str();
}

} // namespace

int _tmain(int argc, char* argv[])
{
	string filename = argv[1];
	ifstream fin(filename.c_str());
	assert(fin.good());

	string in;
	getline(fin, in, '\0');

	string result = parse(in);

	string out_name(filename);
	out_name += ".ipp";
	ofstream fout(out_name.c_str());
	assert(fout.good());
	fout << result;

	return 0;
}

